//////////////////////////////////////////////////////////////////////
// Video Capture using DirectShow
// Author: Shiqi Yu (shiqi.yu@gmail.com)
// Thanks to:
//		HardyAI@OpenCV China
//		flymanbox@OpenCV China (for his contribution to function CameraName, and frame width/height setting)
// Last modification: April 9, 2009
//////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////
// ʹ˵
//   1. CameraDS.h CameraDS.cppԼĿ¼DirectShowƵĿ
//   2. ˵ Project->Settings->Settings for:(All configurations)->C/C++->Category(Preprocessor)->Additional include directories
//      Ϊ DirectShow/Include
//   3. ˵ Project->Settings->Settings for:(All configurations)->Link->Category(Input)->Additional library directories
//      Ϊ DirectShow/Lib
//////////////////////////////////////////////////////////////////////

#ifndef CCAMERA_H
#define CCAMERA_H

#define WIN32_LEAN_AND_MEAN

#include <atlbase.h>
#include "qedit.h"
#include "dshow.h"
#include <windows.h>
#include <cxcore.h>
#include <winnt.h>

#define MYFREEMEDIATYPE(mt)	{if ((mt).cbFormat != 0)		\
					{CoTaskMemFree((PVOID)(mt).pbFormat);	\
					(mt).cbFormat = 0;						\
					(mt).pbFormat = NULL;					\
				}											\
				if ((mt).pUnk != NULL)						\
				{											\
					(mt).pUnk->Release();					\
					(mt).pUnk = NULL;						\
				}}									


class CCameraDS  
{
private:
	bool	m_IsOpen;
	IplImage * m_pFrame;
	bool m_bConnected;
	int m_nWidth;
	int m_nHeight;
	bool m_bLock;
	bool m_bChanged;
	long m_nBufferSize;

	CComPtr<IGraphBuilder> m_pGraph;
	CComPtr<IBaseFilter> m_pDeviceFilter;
	CComPtr<IMediaControl> m_pMediaControl;
	CComPtr<IBaseFilter> m_pSampleGrabberFilter;
	CComPtr<ISampleGrabber> m_pSampleGrabber;
	CComPtr<IPin> m_pGrabberInput;
	CComPtr<IPin> m_pGrabberOutput;
	CComPtr<IPin> m_pCameraOutput;
	CComPtr<IMediaEvent> m_pMediaEvent;
	CComPtr<IBaseFilter> m_pNullFilter;
	CComPtr<IPin> m_pNullInputPin;

private:
	bool BindFilter(int nCamIDX, IBaseFilter **pFilter);
	void SetCrossBar();

public:
	CCameraDS();
	virtual ~CCameraDS();

	//ͷnCamIDָĸͷȡֵΪ0,1,2,...
	//bDisplayPropertiesָʾǷԶͷҳ
	//nWidthnHeightõͷĿ͸ߣͷ֧趨ĿȺ͸߶ȣ򷵻false
	bool OpenCamera(int nCamID, bool bDisplayProperties=false, int nWidth=320, int nHeight=240);

	//رͷԶ
	void CloseCamera();

	//ͷĿ
	//ԲôCCameraDSʵint c=CCameraDS::CameraCount();õ
	static int CameraCount(); 

	//ͷıŷͷ
	//nCamID: ͷ
	//sName: ڴͷֵ
	//nBufferSize: sNameĴС
	//ԲôCCameraDSʵCCameraDS::CameraName();õ
	static int CameraName(int nCamID, char* sName, int nBufferSize);

	//ͼ
	int GetWidth(){return m_nWidth;} 

	//ͼ߶
	int GetHeight(){return m_nHeight;}

	//ץȡһ֡صIplImageֶͷţ
	//ͼݵΪRGBģʽTop-down(һֽΪϽ)IplImage::origin=0(IPL_ORIGIN_TL)
	IplImage * QueryFrame();
};

#endif 
